/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*                                                                   */
/*        MADE - Macintosh Application Development Essentials        */
/*        ---------------------------------------------------        */
/*           (c) Sig Software, http://www.sigsoftware.com/           */
/*                                                                   */
/* These files can only be used for experimental purposes. To obtain */
/* fully commented code, source code for the functions in Essential  */
/*   Extras.h and permission for usage in final projects, you must   */
/*    purchase a license. See documentation for more information.    */
/*                                                                   */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*                                                                   */
/*  User Settings.h                                                  */
/*  ---------------                                                  */
/*                                                                   */
/*  All the necessary settings for the MADE package.                 */
/*                                                                   */
/*  Version 1.0.0 - 10th November 1996                               */
/*  Version 1.0.1 - 4th June 1997 - Fixed macro, function names      */
/*  Version 1.1.0 - 29th January 1998 - Modeless dialog support      */
/*  Version 1.2.0 - 20th November 1998 - Open App event support      */
/*  Version 1.4.0 - 26th May 1999 - Renamed from Essential Settings  */
/*                                                                   */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#define		Project_Under_Development		1
				// Controls all assertions. If 1, any Assert statement will be checked,
				// and if they fail a dialog box with several options will be displayed.
				// If 0, Assert statements are ignored, and next 3 options don't matter.
#define		Initialise_Allocated_Memory		1
				// Overwrites memory before and after use with OxAA bytes. This is extremely
				// useful for eliminating intermittent errors where non-initialised memory is
				// used. Now you'll always get an error, and will be able to spot the 0xAA
				// values. Used in AllocPtr, AllocHandle, DestroyPtr, DestroyHandle.
#define		Assert_Memory_Locking			1
				// Ensures status is changed when locking or unlocking handles. This is useful
				// where you might have one function inside another which passes it a handle.
				// If both outer and inner functions lock and unlock the handle, there will
				// be a point where the outer functions expects the handle to be locked, but
				// it will have been unlocked. Used in LockHandle, UnlockHandle.
#define		Move_On_Handle_Allocation		1
				// Moves memory around whenever a handle is allocate. This helps identify
				// intermittent dangling-pointer errors where the referred block has been
				// moved elsewhere, but some code still expects it to be in the same place.
				// Now such code will almost always fail, instead of just when memory is
				// tight. Used in AllocHandle only.

#define		Use_AppleEvents					1
				// Brings in code to deal with AppleEvents
#define		Insist_On_AppleEvent_Support	0
				// Complains then quits if no AppleEvent manager
#define		Handle_Open_Application_Event	1
				// Creates and installs handler for Open Application event
#define		Handle_Open_Documents_Event		1
				// Creates and installs handler for Open Documents event
#define		Handle_Print_Documents_Event	1
				// Creates and installs handler for Print Documents event
#define		Handle_Quit_Application_Event	1
				// Creates and installs handler for Quit Application event
#define		Support_Modeless_Dialogs		1
				// Adds event processing support for modeless dialogs

#define		Use_Drag_Manager				0
				// Brings in code to deal with Drag receiving and tracking
				// if you switch this on, add the DragLib library to your project
#define		Insist_On_Drag_Manager_Support	0
				// Complains then quits if no drag manager

#define		Emergency_Memory_Reserve		16384
				// Number of bytes to reserve for error handling
#define		Event_Sleep_Time				6
				// Number of 'ticks' to give background processes at idle time
